<template>
  <div :class="{ hide: !this.showModal }" class="mimodal hidde font-sans">
    <div class="max-w-md mx-auto bg-gray-100 p-5">
      <h3 v-show="this.esEditable" class="mb-2 leading-none tracking-tight text-gray-900  dark:text-gray-500 text-left">
        Editar colaborador</h3>
      <h3 v-show="!this.esEditable" class="mb-2 leading-none tracking-tight text-gray-900  dark:text-gray-500 text-left">
        Crear colaborador</h3>
      <form ref="myForm" class="max-w-md mx-auto mt-5">
        <div class="mb-4">
          <label for="lastName" class="block text-gray-700 text-sm font-medium mb-2">Nombre (s) <strong
              class="text-red-400">*</strong></label>
          <input v-model="colaborador.lastName" type="text" id="lastName" class="form-input w-4/5" required>
        </div>
        <div class="mb-4">
          <label for="firstName" class="block text-gray-800 text-sm font-medium mb-2">Apellido paterno <strong
              class="text-red-400">*</strong></label>
          <input v-model="colaborador.firstName" type="text" id="firstName" class="form-input w-4/5">
        </div>
        <div class="mb-4">
          <label for="maidenName" class="block text-gray-800 text-sm font-medium mb-2">Apellido materno <strong
              class="text-red-400">*</strong></label>
          <input v-model="colaborador.maidenName" type="text" id="maidenName" class="form-input w-4/5">
        </div>
        <div class="mb-4">
          <label for="age" class="block text-gray-800 text-sm font-medium mb-2">Edad <strong
              class="text-red-400">*</strong></label>
          <input v-model="colaborador.age" type="text" id="age" class="form-input w-4/5">
        </div>
        <div class="mb-4">
          <label for="weight" class="block text-gray-800 text-sm font-medium mb-2">Salario <strong
              class="text-red-400">*</strong></label>
          <input v-model="colaborador.weight" type="text" id="weight" class="form-input w-4/5">
        </div>
      </form>

      <div class="text-center m-7">
        <button @click="cerrarModal"
          class="bg-white text-base font-bold hover:bg-blue-100 text-sky-400 py-2 px-4 rounded border-2 border-blue-400 mr-2">
          Cancelar
        </button>
        <button @click="submitForm"
          class="bg-blue-300 text-base font-bold hover:bg-blue-400 text-white py-2 px-4 rounded border-2 border-white ml-2">
          {{ esEditable ? 'Actualizar colaborador' : 'Crear colaborador' }}
        </button>
      </div>
    </div>
  </div>
</template>
  
<script>
export default {
  props: {
    DatosColaborador: Object,
  },
  data() {
    return {
      colaborador: {
        id: null,
        age: null,
        firstName: null,
        maidenName: null,
        lastName: null,
        weight: null
      },
      esEditable: false,
      showModal: false,
    };
  },
  created() {
    let me = this;
    /* 18/01/2024 KCASTILLO
    Al crear el componente, declaramos una escucha en el evento ModalVisible, que se ejecutará si algún
    componente envia un evento con este nombre*/
    this.$root.$on('ModalVisible', (visible) => {
      me.showModal = visible;
    });
    this.$root.$on('SetDatosColaborador', (data) => {
      me.colaborador = { ...data };
      me.esEditable = true
    });
  },
  mounted() {
    // Valida si el colaborador tiene datos, para asignarlo al modelo local
    if (this.DatosColaborador) {
      this.colaborador = { ...this.DatosColaborador };
      this.esEditable = false;
    }
  },
  methods: {
    /**18/01/2024 KCASTILLO
   * Se emiten notificaciones y para poder ocultar y resetear el modal formilario.
   * @param 
   */
    submitForm() {
      //aquí se puede agregar la validacion del form. --para este ejemplo no es requerido
      this.esEditable == true ?
        this.editarColaborador()
        : this.guardaColaborador();

      this.$root.$emit('ModalVisible', false)
      this.limpiarForm();
    },
    /** Limpia formulario y oculta el modal formulario */
    cerrarModal() {
      this.limpiarForm();
      this.showModal = false
    },
    /** Limpia formulario asignando los campos en null y asignando la valriable local esEditable en false
     *  esta es la variable que depende el modal para mostrarse
    */
    limpiarForm() {
      this.colaborador = {
        id: null,
        age: null,
        firstName: null,
        maidenName: null,
        lastName: null,
        weight: null
      };
      this.esEditable = false;
    },
    /* 19/01/2024 KCASTILLO
    * Consume API para actualizar datos de un colaborador especifico por el id
    */
    editarColaborador() {
      let url = `${process.env.VUE_APP_USRAPI}/${this.colaborador.id}`;
      fetch(url, {
        method: 'PUT',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify({
          firstName: this.colaborador.firstName,
          maidenName: this.colaborador.maidenName,
          lastName: this.colaborador.lastName,
          age: this.colaborador.age,
          weight: this.colaborador.weight
        })
      })
        .then(res => res.json())
        .then(      this.$root.$emit('NotificacionAlert', "El colaborador fue editado"))
        .catch(error => {
          this.$root.$emit('NotificacionAlert', error);
          console.error('There was a problem with the fetch operation:', "Opps ocurrio un error.");
        });

    },
    /* 19/01/2024 KCASTILLO
    * Consume API para guardar datos nuevos de un colaborador
    */
    guardaColaborador() {
      let url = `${process.env.VUE_APP_USRAPI}/add`;
      fetch(url, {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify({
          firstName: this.colaborador.firstName,
          maidenName: this.colaborador.maidenName,
          lastName: this.colaborador.lastName,
          age: this.colaborador.age,
          weight: this.colaborador.weight
        })
      })
        .then(res => res.json())
        .then(this.$root.$emit('NotificacionAlert', "El colaborador fue creado"))
        .catch(error => {
          this.$root.$emit('NotificacionAlert', error);
          console.error('There was a problem with the fetch operation:', "Opps ocurrio un error.");
        });
    },
  },
};
</script>
<style scoped>
.mimodal {
  position: fixed;
  z-index: 1;
  padding-top: 2%;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  overflow: auto;
  background-color: rgba(0, 0, 0, 0.801);
  background-color: rgba(107, 107, 107, 0.89);
}

.hide {
  visibility: hidden !important;
}
</style>